#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>

#define BAUDRATE B115200
#define MODEMDEVICE "/dev/ttyS0"
#define _POSIX_SOURCE 1 /* POSIX Υ */
#define FALSE 0
#define TRUE 1
/* packetSize = 128 byte */
/* no DataLength */
/* High Gain no skelch */

volatile int STOP=FALSE;

/* input: RS232c (output from jpeg camera)
   output: jpeg-data
   usage: (e.g.) ./jpegcam2jpg3.o jpegdata.jpg  */
/* example of input data:
   4byte hedder + 122byte data + 2byte verify

   00 00 7A 00 FF D8 FF E0 00 11 ..122/128.. 77 00  (FFD8:jpeg start)
   01 00 7A 00 09 0A 16 17 18 19 ...        (^^^^^verify code)
   02 00 7A                      (007A: number of data = 122)
     ...
   92 00 BC ...      FF D9 00 00 C4 00    (FFD9: jpeg last)
*/
int main(int argc, char *argv[])
{
    FILE *fout;
    unsigned char in[10];
    unsigned char buf[300];
    unsigned char FF=0xFF, D9=0xD9;
    int fd, i, j, I, in0, in1, length, in2, buf246, buf247, pkNo;
    struct termios oldtio, newtio;

    if((fout = fopen(argv[1], "w")) == NULL ) {
          fprintf(stderr,"ϥե륪ץ󥨥顼\n");
          exit(EXIT_FAILURE); }
          else  printf("output file opend\n");

    fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY ); 

    if (fd < 0) {perror(MODEMDEVICE); exit(-1); }
          else  printf("serial port opend\n");
    tcgetattr(fd,&oldtio);
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
/* set input mode (non-canonical, no echo,...) */
    newtio.c_lflag = 0;
/*    newtio.c_cc[VTIME]    = 1;  */  /* 饯֥0.1sec */
    newtio.c_cc[VTIME]    = 0.04;  /* 饯֥0.004sec */
/*    newtio.c_cc[VMIN]     = 250; */  /* 256ʸޤǥ֥å */
    newtio.c_cc[VMIN]     = 122;   /* 128ʸޤǥ֥å */

    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);
/* skip until effective pixel data */
/*
r1: read(fd, in, 1);
    if(in[0] != 0) goto r1;
    read(fd, in, 1);
    if(in[1] != 0) goto r1;
    read(fd, in, 1);
    if(in[2] != 122) goto r1;
    read(fd, in, 1);
    if(in[3] != 0) goto r1;
*/
r1:while(1){
    read(fd, in, 1);
    if(in[0] == 0) {
       in0 = in[0];
        read(fd, in, 1);
        if(in[0] == 0) {
           in1 = in[0];
            read(fd, in, 1);
            if(in[0] == 122) {
                in2 = in[0];
                read(fd, in, 1);
                if(in[0] == 0) break;
                           }
                     }
                 }
            }
/* receive pixel data 1st line */
    read(fd, buf, 122);
    for(i=0; i<122; i++) fputc(buf[i], fout);
    pkNo = in1 * 256 + in0;
    printf("packetNo=%d, dataN=%d\n", pkNo, in2);
    read(fd, in, 2);
/* receive pixel data following lines */
   for(j=1; j < 1024; j++) {
       read(fd,in,4);
       in2 = in[2];
       read(fd,buf,in2);
       for(i=0; i< in2; i++) fputc(buf[i], fout);
       pkNo = in[1] * 256 + in[0];
       printf("packetNo=%d, dataN=%d\n", pkNo, in2);
       if(in2 != 122) break;
       if(buf[116]==0xff && buf[117]==0xD9) break; 
       read(fd,in,2);}
    fclose(fout);
    close(fd);
}
